unit DsInformation;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UAboutBoxInfo,Winsock;

 Type
  TODVolumeInformation = record
    VolumeName  : string;
    VolumeSerialNumber:dword;
    MaximumComponentLength,
    FileSystemFlags : Cardinal;
    FileSystemName : string;       
  end;

type
  TDsInformation = class(TComponent)
  private
    { Private declarations }
    FSetAbout:Boolean;
    Procedure FAbout(Value:Boolean);
  protected
    { Protected declarations }
  public
    { Public declarations }
    Function  GetLocalPcName():String;
    Function  GetLocalUserName:String;
    Function  GetDiskSerialID(cDriveName : char ) : String;
    Function  GetLocalIP : string;
    Function  GetThisExeVersion: String;
    Procedure MsgExcl(Messaggio:String);
    Procedure MsgStop(Messaggio:String);
    Procedure MsgErr(Messaggio:String);
    Procedure MsgWarn(Messaggio:String);
    Procedure MSG(Messaggio:String);
  published
    { Published declarations }
    Property About:Boolean Read FSetAbout  Write FAbout;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('DigitStudios', [TDsInformation]);
end;

///------------------------

Procedure TDsInformation.FAbout(Value:Boolean);
Begin
 If Not Value Then Exit;
 If AboutBoxInfo=Nil then
  AboutBoxInfo:=TAboutBoxInfo.Create(Application);

 AboutBoxInfo.showmodal;

 AboutBoxInfo.Release;
 ABoutBoxInfo:=Nil;
End;

///------------------------

Function TDsInformation.GetLocalPcName:String;
Var
Size: DWORD;
Buffer: PChar;
Begin
    Result:='Errore';
    Size :=20 ;
    GetMem(Buffer, Size);
    try
       GetComputerName(Buffer,size);
       Result:=Buffer;
    finally
      FreeMem(Buffer);
    end;
End;

///------------------------

//Procedura che legge il numero di serie del HD
function TDsInformation.GetDiskSerialID(
  cDriveName : char ) : String;
        procedure RealizeLength(var S: string);
        begin
          SetLength (S, StrLen (PChar(S)))
        end;

        function GetSerialStr(Serial:Integer):String;
        begin
        result := Format ('%4x-%4x', [longrec(Serial).hi, longrec(Serial).lo]);
        while pos(' ',result)>0 do result[pos(' ',result)]:='0';
        end;

        function GetVolumeInfo (D : char; var V : TODVolumeInformation) : boolean;
        var
          O : integer;
        begin
          O := SetErrorMode (SEM_FAILCRITICALERRORS);
          try
            with V do
             begin
              SetLength (VolumeName, MAX_PATH);
              SetLength (FileSystemName, MAX_PATH);
              VolumeSerialNumber := 0;
              MaximumComponentLength := 0;
              FileSystemFlags := 0;
              Result := Windows.GetVolumeInformation (PChar (D+':\'), PChar (VolumeName), MAX_PATH,
                @VolumeSerialNumber, MaximumComponentLength, FileSystemFlags,
                PChar (FileSystemName), MAX_PATH);
              RealizeLength (VolumeName);
              RealizeLength (FileSystemName)
             end
          finally
            SetErrorMode (O)
          end
        end;

var
volinfo : todvolumeinformation;
begin
GetVolumeInfo(cDriveName,volinfo);
Result:=(getSerialStr(volinfo.VolumeSerialNumber));
end;

///------------------------

Function TDsInformation.GetLocalIP : string;
type
    TaPInAddr = array [0..10] of PInAddr;
    PaPInAddr = ^TaPInAddr;
var
    phe  : PHostEnt;
    pptr : PaPInAddr;
    Buffer : array [0..63] of char;
    I    : Integer;
    GInitData      : TWSADATA;

begin
    WSAStartup($101, GInitData);
    Result := '';
    GetHostName(Buffer, SizeOf(Buffer));
    phe :=GetHostByName(buffer);
    if phe = nil then Exit;
    pptr := PaPInAddr(Phe^.h_addr_list);
    I := 0;
    while pptr^[I] <> nil do begin
      result:=StrPas(inet_ntoa(pptr^[I]^));
      Inc(I);
    end;
    WSACleanup;
end;

///------------------------

Function TDsInformation.GetLocalUserName:String;
Var
Size: DWORD;
Buffer: PChar;
Begin
    Result:='Errore';
    Size :=20 ;
    GetMem(Buffer, Size);
    try
       GetUserName(Buffer,size);
       Result:=Buffer;
    finally
      FreeMem(Buffer);
    end;
End;

///------------------------

// Funzione MsgBox
Procedure TDsInformation.MSG(Messaggio:String);
Begin
     Application.MessageBox(PChar(Messaggio),'Avviso',MB_ICONINFORMATION);
End;
///------------------------

// Funzione MsgBox
Procedure TDsInformation.MsgWarn(Messaggio:String);
Begin
     Application.MessageBox(PChar(Messaggio),'Attenzione',MB_ICONWARNING);
End;
///------------------------

// Funzione MsgBox
Procedure TDsInformation.MsgErr(Messaggio:String);
Begin
     Application.MessageBox(PChar(Messaggio),'Errore',MB_ICONERROR);
End;
///------------------------

// Funzione MsgBox
Procedure TDsInformation.MsgStop(Messaggio:String);
Begin
     Application.MessageBox(PChar(Messaggio),'Stop',MB_ICONHAND);
End;
///------------------------

// Funzione MsgBox
Procedure TDsInformation.MsgExcl(Messaggio:String);
Begin
     Application.MessageBox(PChar(Messaggio),'Attenzione',MB_ICONEXCLAMATION);
End;


 ///------------------------

 function TDsInformation.GetThisExeVersion: String;

    Procedure GetBuildInfo(var V1, V2, V3, V4: Word);
     var
       VerInfoSize: DWORD;
       VerInfo: Pointer;
       VerValueSize: DWORD;
       VerValue: PVSFixedFileInfo;
       Dummy: DWORD;
     begin
     V1:=0;
     V2:=0;
     V3:=0;
     V4:=0;
     VerInfoSize := GetFileVersionInfoSize(PChar(ParamStr(0)), Dummy);
     GetMem(VerInfo, VerInfoSize);
     GetFileVersionInfo(PChar(ParamStr(0)), 0, VerInfoSize, VerInfo);
     VerQueryValue(VerInfo, '\', Pointer(VerValue), VerValueSize);
     with VerValue^ do
       begin
       V1 := dwFileVersionMS shr 16;
       V2 := dwFileVersionMS and $FFFF;
       V3 := dwFileVersionLS shr 16;
       V4 := dwFileVersionLS and $FFFF;
       end;
     FreeMem(VerInfo, VerInfoSize);
     end;

 var
   V1, V2, V3, V4: Word;
 begin
  V1:=0;
  V2:=0;
  V3:=0;
  V4:=0;
 GetBuildInfo(V1, V2, V3, V4);
 Result := Format('%d.%d.%d.%d', [V1, V2, V3, V4]);
 end;

///------------------------


end.
